HOST :=
ifeq ($(OS),DOS)
	HOST := dos
else
	ifeq ($(OS),Windows_NT)
   		HOST := win32
	else
   		ifdef WINDIR
   			HOST := win32
		else
       		ifdef windir
       			HOST := win32
		else
		ifdef HOME
			HOST := linux
		endif
       		endif
   		endif
	endif
endif

ifndef TARGET
	ifndef HOST
		CHECKHOST_MSG := $(error error: TARGET not defined and HOST couldn't be guessed)
	else
		CHECKHOST_MSG :=
	endif
	TARGET := $(HOST)
endif

# set default command names
#

ifeq ($(TARGET),linux)
    EXEEXT :=
    RM := rm
    EXE_PFX := ./
    CP := cp -r
    ifndef INSTALLDIR
        INSTALLDIR := /usr/share/freebasic
    endif

else
    ifeq (msys,$(findstring msys,$(shell sh --version 2>NULL)))
        EXE_PFX := ./
        RM := rm
        CP := cp -r

        ifndef INSTALLDIR
            INSTALLDIR := /c/Program\ Files/FreeBASIC
        endif

    else
        RM := del
        CP := copy
        ifndef INSTALLDIR
            INSTALLDIR := "C:\Program Files\FreeBASIC"
        endif
    endif
    EXE_EXT := .exe

endif

MD := mkdir

ifeq ($(VERBOSE),0)
FBC := @fbc$(EXE_EXT)
else
FBC := fbc$(EXE_EXT)
endif

INCDIR := inc
SRCDIR := src
LIBDIR := lib/$(TARGET)

ifndef INCPREFIX
	ifndef STANDALONE
		INCPREFIX := inc
	else
		INCPREFIX := include/freebasic
	endif
endif

ifndef LIBPREFIX
	ifndef STANDALONE
		LIBPREFIX := lib/$(TARGET)
	else
		LIBPREFIX := lib/freebasic/$(TARGET)
	endif
endif

