#Include Once "mud-gui/widgets/DblSpinBox.bi"
#include once "string.bi"

Namespace ui
	
	constructor DblSpinBox ( byval parent as BaseWidget ptr = 0, ByVal _val_ As double = 0.0, byval _step_ as double = .1 )

		if parent <> 0 then
			if parent->cl <> layout_t.canHaveLayout then ShowError("DblSpinBox widget must have a valid parent.")
			SetParent(parent)

		end if
		setMinimum = -10.0
		setMaximum = 10.0
		setStep_ = _step_
		setFormatString = "###0.00"
		setRollover = 1
		(BaseObject).id = ui.widgetids.DblSpinBox
		(BaseObject).cl = layout_t.canHaveLayout

		connectSignal(@This,resize,DblSpinBox.resize_handler)

		m_gl = New GridLayout( toBaseWidget(@This), 6, 2 )
		m_le = New LineEdit( ,format(_val_,formatString) )
		m_le->setEditable = FALSE 

		m_up = New PushButton(, "^")
		m_down = New PushButton(,"v")


		connectSignal( m_up, clicked, DblSpinBox.m_up_clicked )
		connectSignal( m_down, clicked, DblSpinBox.m_down_clicked )

		m_gl->PlaceWidget( toBaseWidget(m_le), 1, 1, 5, 2 )
		m_gl->PlaceWidget( toBaseWidget(m_up), 6, 1 )
		m_gl->PlaceWidget( toBaseWidget(m_down), 6, 2 )

	End Constructor

	IMP_PROPERTY( DblSpinBox, step_, double )
	IMP_PROPERTY( DblSpinBox, minimum, double )
	IMP_PROPERTY( DblSpinBox, maximum, double )
	IMP_PROPERTY( DblSpinBox, rollover, ubyte )
	IMP_BYREF_PROPERTY( DblSpinBox, formatString, string )
	
	property DblSpinBox.value ( ) As double
		Return Val(m_le->text)
	End property
	
	property DblSpinBox.setValue( byval _t_ as double )
		m_le->setText = format(_t_,formatString) 
	end property

	STATIC_SLOT(DblSpinBox.resize_handler)
		Var z = Cast(DblSpinBox Ptr, ref )
		z->m_gl->___base.width = z->___base.width
		z->m_gl->___base.height = z->___base.height
		z->m_gl->___base.x = z->___base.x
		z->m_gl->___base.y = z->___base.y
		If z->m_gl->m_grid <> 0 Then DeAllocate z->m_gl->m_grid
		z->m_gl->sizeGrid( 6, 2 )
		Return 0
	Endslot

	STATIC_SLOT(DblSpinBox.m_up_clicked)
		Cast( PushButton ptr, ref )->m_isdown = 0
		line ref->buffer, (0,0)-(ref->width,ref->height), rgb(&hc9,&hc9,&hc9 ), BF


		Var pz = ref->Parent
		if pz = 0 then ShowError("Parent must not be null for child widget. l69")
		if pz->Parent = 0 then ShowError("Parent must not be null for child widget. l70")
		if pz->Parent->id <> widgetids.DblSpinBox then ShowError("WID does not match expected.")
		var z = cast( DblSpinBox ptr, pz->Parent )
		var m_max = z->maximum
		var m_min = z->minimum
		var m_step = z->step_
		Var curval = z->value
		if z->rollover = 0 then
			If curval <= m_max Then z->setValue = iif((curval + m_step)>m_max,m_max,curval+m_step) 
		else
			If curval <= m_max Then z->setValue = iif((curval + m_step)>m_max,m_min,curval+m_step) 
		end if


		Return 1
	Endslot

	STATIC_SLOT(DblSpinBox.m_down_clicked)
		Cast( PushButton ptr, ref )->m_isdown = 0
		line ref->buffer, (0,0)-(ref->width,ref->height), rgb(&hc9,&hc9,&hc9 ), BF


		Var pz = ref->Parent
		if pz = 0 then ShowError("Parent must not be null for child widget. l86")
		if pz->Parent = 0 then ShowError("Parent must not be null for child widget. l87")
		if pz->Parent->id <> widgetids.DblSpinBox then ShowError("WID does not match expected.")
		var z = cast( DblSpinBox ptr, pz->Parent )
		var m_max = z->maximum
		var m_min = z->minimum
		var m_step = z->step_
		Var curval = z->value
		if z->rollover = 0 then
			If curval >= m_min Then z->setValue = iif((curval - m_step)<m_min,m_min,curval-m_step) 
		else
			If curval >= m_min Then z->setValue = iif((curval - m_step)<m_min,m_max,curval-m_step) 
		end if


		Return 1
	Endslot


End Namespace
